#
# Copyright 2016-2018, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in
#       the documentation and/or other materials provided with the
#       distribution.
#
#     * Neither the name of the copyright holder nor the names of its
#       contributors may be used to endorse or promote products derived
#       from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# src/test/ex_libpmemobj/TEST20 -- unit test for libpmemobj examples
#

# standard unit test setup
. ..\unittest\unittest.PS1

require_test_type medium
require_build_type debug nondebug
require_no_unicode

setup

expect_normal_exit $Env:EXAMPLES_DIR\ex_pmemobj_array $DIR\testfile alloc int 23 int > out$Env:UNITTEST_NUM.log
expect_normal_exit $Env:EXAMPLES_DIR\ex_pmemobj_array $DIR\testfile alloc PMEMoid 17 PMEMoid >> out$Env:UNITTEST_NUM.log
expect_normal_exit $Env:EXAMPLES_DIR\ex_pmemobj_array $DIR\testfile alloc TOID 11 TOID >> out$Env:UNITTEST_NUM.log

expect_normal_exit $Env:EXAMPLES_DIR\ex_pmemobj_array $DIR\testfile print int >> out$Env:UNITTEST_NUM.log
expect_normal_exit $Env:EXAMPLES_DIR\ex_pmemobj_array $DIR\testfile print PMEMoid >> out$Env:UNITTEST_NUM.log
expect_normal_exit $Env:EXAMPLES_DIR\ex_pmemobj_array $DIR\testfile print TOID >> out$Env:UNITTEST_NUM.log

expect_normal_exit $Env:EXAMPLES_DIR\ex_pmemobj_array $DIR\testfile realloc int 17 >> out$Env:UNITTEST_NUM.log
expect_normal_exit $Env:EXAMPLES_DIR\ex_pmemobj_array $DIR\testfile realloc PMEMoid 11 >> out$Env:UNITTEST_NUM.log
expect_normal_exit $Env:EXAMPLES_DIR\ex_pmemobj_array $DIR\testfile realloc TOID 13 >> out$Env:UNITTEST_NUM.log

expect_normal_exit $Env:EXAMPLES_DIR\ex_pmemobj_array $DIR\testfile print int >> out$Env:UNITTEST_NUM.log
expect_normal_exit $Env:EXAMPLES_DIR\ex_pmemobj_array $DIR\testfile print PMEMoid >> out$Env:UNITTEST_NUM.log
expect_normal_exit $Env:EXAMPLES_DIR\ex_pmemobj_array $DIR\testfile print TOID >> out$Env:UNITTEST_NUM.log

check

pass
