#
# Copyright 2016-2018, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in
#       the documentation and/or other materials provided with the
#       distribution.
#
#     * Neither the name of the copyright holder nor the names of its
#       contributors may be used to endorse or promote products derived
#       from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# src\test\util_poolset_foreach\TEST0 -- unit test for util_poolset_foreach
#

# standard unit test setup
. ..\unittest\unittest.ps1

require_test_type medium

require_fs_type any

setup

create_poolset $DIR\pool.set1 128K:$DIR\testfile:x
create_poolset $DIR\pool.set2 128K:$DIR\testfile1:x 32M:$DIR\testfile2:x
create_poolset $DIR\pool.set3 `
	32M:$DIR\testfile11:x 32M:$DIR\testfile12:x `
	R 64M:$DIR\testfile21:x 32M:$DIR\testfile22:x
create_poolset $DIR\pool.set4 `
	32M:$DIR\testfile11:x 32M:$DIR\testfile12:x `
	R 64M:$DIR\testfile21:x 32M:$DIR\testfile22:x `
	R 64M:$DIR\testfile31:x 64M:$DIR\testfile32:x

expect_normal_exit $Env:EXE_DIR\util_poolset_foreach$Env:EXESUFFIX `
	$DIR\pool.set1 `
	$DIR\pool.set2 `
	$DIR\pool.set3 `
	$DIR\pool.set4

check

pass
